#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

.plugin lite86;                     ;the ultimate compression rutine, saved 1,207 bytes

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068
spritedata  =$9000

Var_X1      equ   $ca00
Var_Y1      equ   $ca00+10
Var_X2      equ   $ca00+20
Var_Y2      equ   $ca00+30
Var_M       equ   $ca00+40

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String0                     ;print string

String0:    .db "Algebra Solver v2.6",0

Start:
    call init_ubersprite            ;goes to init_ubersprite
    call _flushallmenus             ;clears all key codes
    call _clrScrn                   ;clears the lcd and graph screen
    call MenuTitle                  ;goes to MenuTitle
    ld hl,String5                   ;loads hl with string
    call _vputs                     ;prints in small text
    res 3,(iy+5)                    ;reverts text back to black on white
    ld bc,3+(256*12)                ;loads x,y coordinates into bc
    ld ix,BottomLeft                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprite
    ld bc,117+(256*12)              ;loads x,y coordinates into bc
    ld ix,BottomRight               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprite
    ld hl,$fd31                     ;loads screen coordinates into hl
    ld b,14                         ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$fcb0                     ;loads screen coordinates into hl
    ld (hl),%00100000               ;loads video mem @ hl w/ line
    ld hl,$fcbf                     ;loads screen coordinates into hl
    ld (hl),%00000100               ;loads video mem @ hl w/ line
    ld hl,(256*1)+1                 ;loads x,y coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String0                   ;loads hl with string
    call _puts                      ;prints in large text
    call QuadraticBlackText         ;goes to QuadraticBlackText
    call X1Y1X2Y2BlackText          ;goes to X1Y1X2Y2BlackText
QuadraticKey:
    call PythagoreanBlackText       ;goes to PythagoreanBlackText
    call QuitBlackText              ;goes to QuitBlackText
    call QuadraticWhiteText         ;goes to QuadraticWhiteText
QuadraticLoop:
    call _getcode                   ;waits for a key to be presses, stores key to a
    cp K_UP                         ;compares a with Up key
    jr z,QuitKey                    ;if Up jump to QuitKey
    cp K_DOWN                       ;compares a with Down key
    jr z,PythagoreanKey             ;if Down jump to PythagoreanKey
    cp K_EXIT                       ;compares a with Exit key
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a with Alpha key
    call z,CalcOff                  ;if Alpha jump to CalcOff
    cp K_ENTER                      ;compares a with Enter key
    jp z,Quadratic                  ;if enter jump to Quadratic
    cp K_SECOND                     ;compares a with 2nd key
    jp z,Quadratic                  ;if 2nd jump to Quadratic
    jr QuadraticLoop                ;relative jump to QuadraticLoop

PythagoreanKey:
    call QuadraticBlackText         ;goes to QuadraticBlackText
    call X1Y1X2Y2BlackText          ;goes to X1Y1X2Y2BlackText
    call PythagoreanWhiteText       ;goes to PythagoreanWhiteText
PythagoreanLoop:
    call _getcode                   ;waits for a key to be presses, stores key to a
    cp K_UP                         ;compares a with Up key
    jr z,QuadraticKey               ;if Up jump to QuadraticKey
    cp K_DOWN                       ;compares a with Down key
    jr z,X1Y1X2Y2Key                ;if Down jump to X1Y1X2Y2
    cp K_EXIT                       ;compares a with Exit key
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a with Alpha key
    call z,CalcOff                  ;if Alpha jump to CalcOff
    cp K_ENTER                      ;compares a with Enter key
    jp z,Pythagorean                ;if Enter jump to Pythagorean
    cp K_SECOND                     ;compares a with 2nd key
    jp z,Pythagorean                ;if 2nd jump to Pythagorean
    jr PythagoreanLoop              ;relative jump to PythagoreanLoop

X1Y1X2Y2Key:
    call PythagoreanBlackText       ;goes to PythagoreanBlackText
    call QuitBlackText              ;goes to QuitBlackText
    call X1Y1X2Y2WhiteText          ;goes to X1Y1X2Y2WhiteText
X1Y1X2Y2Loop:
    call _getcode                   ;waits for a key to be presses, stores key to a
    cp K_UP                         ;compares a with Up key
    jr z,PythagoreanKey             ;if Up jump to PythagoreanKey
    cp K_DOWN                       ;compares a with Down key
    jr z,QuitKey                    ;if Down jump to QuitKey
    cp K_EXIT                       ;compares a with Exit key
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a with Alpha key
    call z,CalcOff                  ;if Alpha jump to CalcOff
    cp K_ENTER                      ;compares a with Enter key
    jp z,X1Y1X2Y2                   ;if Enter jump to X1Y1X2Y2
    cp K_SECOND                     ;compares a with 2nd key
    jp z,X1Y1X2Y2                   ;if 2nd jump to X1Y1X2Y2
    jr X1Y1X2Y2Loop                 ;relative jump to X1Y1X2Y2Loop

QuitKey:
    call QuadraticBlackText         ;goes to QuadraticBlackText
    call X1Y1X2Y2BlackText          ;goes to X1Y1X2Y2BlackText
    call QuitWhiteText              ;goes to QuitWhiteText
QuitLoop:
    call _getcode                   ;waits for a key to be presses, stores key to a
    cp K_UP                         ;compares a with Up key
    jr z,X1Y1X2Y2Key                ;if Up jump to X1Y1X2Y2
    cp K_DOWN                       ;compares a with Down key
    jp z,QuadraticKey               ;if Down jump to QuadraticKey
    cp K_EXIT                       ;compares a with Exit key
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a with Alpha key
    call z,CalcOff                  ;if Alpha jump to CalcOff
    cp K_ENTER                      ;compares a with Enter key
    jp z,Exit                       ;if 2nd jump to Exit
    cp K_SECOND                     ;compares a with 2nd key
    jp z,Exit                       ;if 2nd jump to Exit
    jr QuitLoop                     ;relative jump to QuitLoop

QuadraticBlackText:
    res 3,(iy+5)                    ;reverts text back to black on white
    ld bc,24+(256*26)               ;loads x,y coordinates into bc
    ld ix,LeftOpen                  ;loads sprite into ix
    call ubersprite                 ;goes to ubersprite
    ld bc,96+(256*26)               ;loads x,y coordinates into bc
    ld ix,RightOpen                 ;loads sprite into ix
    call ubersprite                 ;goes to ubersprite
    ld hl,$fe04                     ;loads screen coordinates into hl
    ld b,8                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOff      ;goes to DrawLineHorizontalOff
QuadraticRepeated:
    ld hl,$fd94                     ;loads screen coordinates into hl
    ld b,8                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$fe14                     ;loads screen coordinates into hl
    ld b,8                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$fd93                     ;loads screen coordinates into hl
    ld (hl),%00000001               ;loads video mem @ hl w/ line
    ld hl,$fe13                     ;loads screen coordinates into hl
    ld (hl),%00000001               ;loads video mem @ hl w/ line
    ld hl,$1A20                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String1                   ;loads hl with string
    call _vputs                     ;prints in small text
    ret                             ;return to call

QuadraticWhiteText:
    set 3,(iy+5)                    ;inverts text to white text on black
    ld bc,24+(256*26)               ;loads x,y coordinates into bc
    ld ix,LeftClosed                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,96+(256*26)               ;loads x,y coordinates into bc
    ld ix,RightClosed               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld hl,$fe04                     ;loads coordinates into hl
    ld b,8                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    jr QuadraticRepeated            ;jump to QuadraticRepeated

PythagoreanBlackText:
    res 3,(iy+5)                    ;reverts text back to black on white
    ld hl,$fea3                     ;loads screen coordinates into hl
    ld b,10                         ;# of times to loop and display @ hl
    call DrawLineHorizontalOff      ;goes to DrawLineHorizontalOff
    ld bc,19+(256*36)               ;loads x,y coordinates into bc
    ld ix,LeftOpen                  ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,101+(256*36)              ;loads x,y coordinates into bc
    ld ix,RightOpen                 ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
PythagoreanRepeated:
    ld hl,$fe33                     ;loads screen coordinates into hl
    ld b,10                         ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$feb3                     ;loads screen coordinates into hl
    ld b,10                         ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$fe33                     ;loads screen coordinates into hl
    ld (hl),%00111111               ;loads video mem @ hl w/ line
    ld hl,$feb3                     ;loads screen coordinates into hl
    ld (hl),%00111111               ;loads video mem @ hl w/ line
    ld hl,$fe3c                     ;loads screen coordinates into hl
    ld (hl),%11111000               ;loads video mem @ hl w/ line
    ld hl,$febc                     ;loads screen coordinates into hl
    ld (hl),%11111000               ;loads video mem @ hl w/ line
    ld hl,$241B                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String2                   ;loads hl with string
    call _vputs                     ;prints in small text
    ret                             ;return to call

PythagoreanWhiteText:
    set 3,(iy+5)                    ;inverts text to white text on black
    ld bc,19+(256*36)               ;loads x,y coordinates into bc
    ld ix,LeftClosed                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,101+(256*36)              ;loads x,y coordinates into bc
    ld ix,RightClosed               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld hl,$fea3                     ;loads screen coordinates into hl
    ld b,9                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$feac                     ;loads screen coordinates into hl
    ld (hl),%11111110               ;loads video mem @ hl w/ line
    jr PythagoreanRepeated          ;jump to PythagoreanRepeated

X1Y1X2Y2BlackText:
    res 3,(iy+5)                    ;reverts text back to black on white
    ld hl,$ff45                     ;loads screen coordinates into hl
    ld b,6                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOff      ;goes to DrawLineHorizontalOff
    ld bc,31+(256*46)               ;loads x,y coordinates into bc
    ld ix,LeftOpen                  ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,89+(256*46)               ;loads x,y coordinates into bc
    ld ix,RightOpen                 ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
X1Y1X2Y2Repeated:
    ld hl,$fed5                     ;loads screen coordinates into hl
    ld b,6                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$ff55                     ;loads screen coordinates into hl
    ld b,6                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$fed4                     ;loads screen coordinates into hl
    ld (hl),%00000011               ;loads video mem @ hl w/ line
    ld hl,$ff54                     ;loads screen coordinates into hl
    ld (hl),%00000011               ;loads video mem @ hl w/ line
    ld hl,$fedb                     ;loads screen coordinates into hl
    ld (hl),%10000000               ;loads video mem @ hl w/ line
    ld hl,$ff5b                     ;loads screen coordinates into hl
    ld (hl),%10000000               ;loads video mem @ hl w/ line
    ld hl,$2E27                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String3                   ;loads hl with string
    call _vputs                     ;prints in small text
    ret                             ;return to call

X1Y1X2Y2WhiteText:
    set 3,(iy+5)                    ;inverts text to white text on black
    ld bc,31+(256*46)               ;loads x,y coordinates into bc
    ld ix,LeftClosed                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,89+(256*46)               ;loads x,y coordinates into bc
    ld ix,RightClosed               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld hl,$ff45                     ;loads screen coordinates into hl
    ld b,6                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$ff44                     ;loads screen coordinates into hl
    ld (hl),%00001111               ;loads video mem @ hl w/ line
    ld hl,$ff4b                     ;loads screen coordinates into hl
    ld (hl),%11100000               ;loads video mem @ hl w/ line
    jr X1Y1X2Y2Repeated             ;jump to X1Y1X2Y2Repeated

QuitBlackText:
    res 3,(iy+5)                    ;reverts text back to black on white
    ld hl,$ffe7                     ;loads screen coordinates into hl
    ld (hl),%00000000               ;loads video mem @ hl w/ line
    ld hl,$ffe8                     ;loads screen coordinates into hl
    ld (hl),%00000001               ;loads video mem @ hl w/ line
    ld bc,49+(256*56)               ;loads x,y coordinates into bc
    ld ix,LeftOpen                  ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,71+(256*56)               ;loads x,y coordinates into bc
    ld ix,RightOpen                 ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
QuitRepeated:
    ld hl,$ff77                     ;loads screen coordinates into hl
    ld (hl),%11111111               ;loads video mem @ hl w/ line
    ld hl,$fff7                     ;loads screen coordinates into hl
    ld (hl),%11111111               ;loads video mem @ hl w/ line
    ld hl,$ff78                     ;loads screen coordinates into hl
    ld (hl),%11111110               ;loads video mem @ hl w/ line
    ld hl,$fff8                     ;loads screen coordinates into hl
    ld (hl),%11111110               ;loads video mem @ hl w/ line
    ld hl,$3839                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String4                   ;loads hl with string
    call _vputs                     ;prints in small text
    ret                             ;return to call

QuitWhiteText:
    set 3,(iy+5)                    ;inverts text to white text on black
    ld bc,49+(256*56)               ;loads x,y coordinates into bc
    ld ix,LeftClosed                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,71+(256*56)               ;loads x,y coordinates into bc
    ld ix,RightClosed               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld hl,$ffe7                     ;loads screen coordinates into hl
    ld (hl),%11111111               ;loads video mem @ hl w/ line
    ld hl,$ffe8                     ;loads screen coordinates into hl
    ld (hl),%11111111               ;loads video mem @ hl w/ line
    jr QuitRepeated                 ;jump to QuitRepeated

MenuTitle:
    call _runindicoff               ;turn off run indicator
    ld bc,3+(256*3)                 ;loads x,y coordinates into bc
    ld ix,TopLeft                   ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,117+(256*3)               ;loads x,y coordinates into bc
    ld ix,TopRight                  ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,27+(256*0)                ;loads x,y coordinates into bc
    ld ix,LeftClosed                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,92+(256*0)                ;loads x,y coordinates into bc
    ld ix,RightClosed               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld hl,$fc31                     ;loads screen coordinates into hl
    ld b,14                         ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$fc64                     ;loads screen coordinates into hl
    ld b,7                          ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    ld hl,$fc6b                     ;loads screen coordinates into hl
    ld (hl),%11111100               ;loads video mem @ hl w/ line
    set 3,(iy+5)                    ;inverts text to white text on black
    ld hl,$0023                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;prints in large text
    ret                             ;return to call

DrawMenuBox:
    ld bc,3+(256*56)                ;loads x,y coordinates into bc
    ld ix,BottomLeft                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,117+(256*56)              ;loads x,y coordinates into bc
    ld ix,BottomRight               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld hl,$fc80                     ;loads screen coordinates into hl
    ld b,48                         ;# of times to loop and display @ c
    ld c,%00010000                  ;what to display @ c
    call DrawVerticalLine           ;goes to DrawVerticalLine
    ld hl,$fc8f                     ;loads screen coordinates into hl
    ld b,48                         ;# of times to loop and display @ c
    ld c,%00001000                  ;what to display @ c
    call DrawVerticalLine           ;goes to DrawVerticalLine
    ld hl,$fff1                     ;loads screen coordinates into hl
    ld b,14                         ;# of times to loop and display @ hl
    call DrawLineHorizontalOn       ;goes to DrawLineHorizontalOn
    res 3,(iy+5)                    ;reverts text back to black on white
    ret                             ;return to call


;========================================
;=         The Quadratic Solver         =
;=          By: Morgan Davies           =
;=                                      =
;=Solves For:           Inputs-         =
;=  x-Intercepts            A=? (not 0) =
;=  y-Intercept             B=?         =
;=  Vertex; (x,y)           C=?         =
;=  Line Of Symmetry                    =
;=  Descriminate                        =
;=  Opens Up or Down?                   =
;========================================

Zero:
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;sets hl with coordinates (0,0)
    ld hl,String9                   ;loads hl with string
    call _puts                      ;prints in large text
    call _getkey                    ;pauses program until a key is pressed
Quadratic:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;sets hl with coordinates (0,0)
    ld hl,E1                        ;loads hl with string
    call Input                      ;goes to Input
    call _op1toop6                  ;op1(A) is copied to op6
    xor a                           ;loads a with 0
    call _setXXop2                  ;move value of a(0) to op2
    call _cpop1op2                  ;compare op1(x1-x2) to op2(0)
    jr z,Zero                       ;if op1 is 0 jump to Zero
    ld hl,E2                        ;loads hl with string
    call Input                      ;goes to Input
    call _stoX                      ;op1(B) ==> real variable x
    ld hl,E3                        ;loads hl with string
    call Input                      ;goes to Input
    call _stoY                      ;op1(C) ==> real variable y
    call _clrScrn                   ;clears lcd and graph screen
    call MenuTitle                  ;goes to MenuTitle
    ld hl,String6                   ;loads hl with string
    call _vputs                     ;prints in small text
    call DrawMenuBox                ;goes to DrawMenuBox
    call _rclX                      ;recall real variable x(B) to op1
    call _op1toop5                  ;op1(B) is copied to op5
    call _FPSQUARE                  ;op1(B) ^2 ==> op1
    call _op1toop4                  ;op1(B^2) is copied to op4
    ld a,4                          ;load a with 4
    call _setXXop2                  ;move value of a(4) to op2
    call _rclY                      ;recall real variable y(C) to op1
    rst 28h                         ;op1(C) 8 op2(4) ==> op1
    call _op6toop2                  ;op6(A) is copied to op2
    rst 28h                         ;op1(C*4) 8 op2(A) ==> op1
    rst 08h                         ;op1(4*A*C) is copied to op2
    call _op4toop1                  ;op4(B^2) is copied to op1
    call _FPSUB                     ;op1(B^2) - op2(4*A*C) ==> op1
    ld hl,$3208                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String10                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    call _ckop1pos                  ;check to see if op1 is positive
    jr nz,NoSolutions               ;if op1 is not positive jump to NoSolutions
    rst 08h                         ;op1(B^2-4*A*C) is copied to op2
    call _op1toop4                  ;op1(B^2-4*A*C) is copied to op4
    xor a                           ;load a with 0
    call _setXXop1                  ;move value of a(0) to op1
    call _cpop1op2                  ;compare op1 and op2
    jr z,OneSolution                ;if op1 is 0 jump to OneSolution
    call _op4toop1                  ;op4(B^2-4*A*C) is copied to op1
    jp nz,TwoSolutions              ;if op1 is not zero jump to TwoSolutions
OneSolution:
    ld a,2                          ;load a with 2
    call _setXXop2                  ;move value of a(2) to op2
    call _op6toop1                  ;op6(A) is copied to op1
    rst 28h                         ;op1(A) * op2(2) ==> op1
    rst 08h                         ;op1(2*A) is copied to op2
    call _rclX                      ;recall real variable x(B) to op1
    call _invop1s                   ;invert sign of op1(B) ==> op1
    call _FPDIV                     ;op1(-B) / op2(2*A) ==> op1
    ld hl,$0A08                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String11                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1425                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String12                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    ld hl,$1d25                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String13                  ;loads hl with string
    call _vputs
    ld hl,String35
    call _vputs                     ;prints in small text
    call _rclY                      ;recall real variable y(C) to op1
    ld hl,$2808                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String17                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    jp LessThanTwoSolutions         ;jump to LessThanTwoSolutions
NoSolutions:
    ld hl,$0A08                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String11                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1425                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String12                  ;loads hl with string
    call _vputs
    ld hl,String35
    call _vputs                     ;prints in small text
    ld hl,$1d25                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String13                  ;loads hl with string
    call _vputs
    ld hl,String35
    call _vputs                     ;prints in small text
    call _rclY                      ;recall real variable y(C) to op1
    ld hl,$2808                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String17                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    jp LessThanTwoSolutions         ;jump to LessThanTwoSolutions
TwoSolutions:
    call _SQROOT                    ;root of op1(B^2-4*A*C) ==> op1
    call _op1toop4                  ;op1(root B^2-4*A*C) is copied to op4
    call _rclX                      ;recall real variable x(B) to op1
    call _invop1s                   ;invert sign of op1(B) ==> op1
    call _op4toop2                  ;op4(root B^2-4*A*C) is copied to op2
    rst 30h                         ;op1(-B) + op2(root B^2-4*A*C) ==> op1
    call _op1toop5                  ;op1(-B + root B^2-4*A*C) is copied to op5
    ld a,2                          ;load a with 2
    call _setXXop2                  ;move value of a(2) to op2
    call _op6toop1                  ;op6(A) is copied to op1
    rst 28h                         ;op1(A) * op2(2) ==> op1
    rst 08h                         ;op1(2*A) is copied to op2
    call _op5toop1                  ;op5(-B + root B^2-4*A*C) is copied to op1
    call _FPDIV                     ;op1(-B + root B^2-4*A*C) / op2(2*A) ==> op1
    ld hl,$0A08                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String11                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1425                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String12                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    call _rclX                      ;recall real variable x(B) to op1
    call _FPSQUARE                  ;op1(B) ^2 ==> op1
    call _op1toop4                  ;op1(B^2) is copied to op4
    ld a,4                          ;load a with 4
    call _setXXop2                  ;move value of a(4) to op2
    call _rclY                      ;recall real variable y(C) to op1
    rst 28h                         ;op1(C) 8 op2(4) ==> op1
    call _op6toop2                  ;op6(A) is copied to op2
    rst 28h                         ;op1(C*4) 8 op2(A) ==> op1
    rst 08h                         ;op1(4*A*C) is copied to op2
    call _op4toop1                  ;op4(B^2) is copied to op1
    call _FPSUB                     ;op1(B^2) - op2(4*A*C) ==> op1
    call _SQROOT                    ;root of op1(B^2-4*A*C) ==> op1
    rst 08h                         ;op1(root B^2-4*A*C) is copied to op2
    call _rclX                      ;recall real variable x(B) to op1
    call _invop1s                   ;invert sign of op1(B) ==> op1
    call _FPSUB                     ;op1(-B) - op2(root B^2-4*A*C) ==> op1
    call _op1toop4                  ;op1(-B - root (B^2-4*A*C)) is copied to op4
    ld a,2                          ;load a with 2
    call _setXXop2                  ;move value of a(2) to op2
    call _op6toop1                  ;op6(A) is copied to op1
    rst 28h                         ;op1(A) * op2(2) ==> op1
    rst 08h                         ;op1(2*A) is copied to op2
    call _op4toop1                  ;op4(-B - root (B^2-4*A*C)) is copied to op1
    call _FPDIV                     ;op1(-B - root (B^2-4*A*C)) / op2(2*A) ==> op1
    ld hl,$1d25                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String13                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    call _rclY                      ;recall real variable y(C) to op1
    ld hl,$2808                     ;load screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String17                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
LessThanTwoSolutions:
    call _getkey                    ;pauses program until a key is pressed
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call MenuTitle                  ;goes to MenuTitle
    ld hl,String6                   ;loads hl with string
    call _vputs                     ;prints in small text
    call DrawMenuBox                ;goes to DrawMenuBox
    ld a,2                          ;load a with 2
    call _setXXop2                  ;move value of a(2) to op2
    call _op6toop1                  ;op6(A) is copied to op1
    rst 28h                         ;op1(A) * op2(2) ==> op1
    rst 08h                         ;op1(2*A) is copied to op2
    call _rclX                      ;recall real variable x(B) to op1
    call _invop1s                   ;invert sign of op1(B) ==> op1
    call _FPDIV                     ;op1(-B) / op2(2*A) ==> op1
    ld hl,$0A08                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String14                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1425                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String15                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    ld hl,$2808                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String18                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    call _op1toop5                  ;op1(x) is copied to op5
    call _FPSQUARE                  ;op1(x) ^2 ==> op1
    call _op6toop2                  ;op6(A) is copied to op2
    rst 28h                         ;op1(x^2) * op2(A) ==> op1
    rst 08h                         ;op1(Ax^2) is copied to op2
    call _rclY                      ;recall real variable y(C) to op1
    rst 30h                         ;op1(C) + op2(Ax^2) ==> op1
    call _stoY                      ;op1(Ax^2 + C) is copied to real variable y
    call _op5toop2                  ;op5(x) is copied to op2
    call _rclX                      ;recall real variable x(B) to op1
    rst 28h                         ;op1(B) * op2(x) ==> op1
    rst 08h                         ;op1(Bx) is copied to op2
    call _rclY                      ;recall real variable y to op1
    rst 30h                         ;op1(Ax^2 + C) + op2(Bx) ==> op1
    ld hl,$1D25                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String16                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    ld hl,$321e                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    xor a                           ;load a with 0
    call _setXXop1                  ;move value of a(0) to op1
    call _op6toop2                  ;op6(A) is copied to op2
    call _FPSUB                     ;op1(0) - op2(A) ==> op1
    call _ckop1pos                  ;check if op1(0-A) is positive
    jr z,OpenUp                     ;if it is positive jump to OpenUp
    ld hl,String19                  ;loads hl with string
ReturnToQuad:
    call _vputs                     ;prints in small text
    call _getkey                    ;pauses program until a key is pressed
    jp Start                        ;jumps to Start
OpenUp:
    ld hl,String20                  ;loads hl with string
    jr ReturnToQuad                 ;relative jump to ReturnToQuad


;========================================
;=    The Pyhtagorean Theorem Solver    =
;=          By: Morgan Davies           =
;=                                      =
;=Solves For:           Inputs-         =
;=  Missing Leg             A=?         =
;=                          B=?         =
;=Checks For:               C=?         =
;=  If # is 0 or negative               =
;========================================

Pythagorean:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    ld hl,(256*3)+2                 ;loads x,y coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String24                  ;loads hl with string
    call _puts                      ;prints string
    ld hl,(256*5)+6                 ;loads x,y coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String23                  ;loads hl with string
    call _puts                      ;prints string
    call MenuTitle                  ;goes to MenuTitle
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    call DrawMenuBox                ;goes to DrawMenuBox
    ld hl,$241D                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String25                  ;loads hl with string
    call _vputs                     ;prints in small text
ABCLoop:
    call _getcode                   ;waits for a key to be presses, stores key to a
    cp K_F2                         ;compares a with F2 key
    jp z,SolutionA                  ;if F2 jump to SolutionA
    cp K_F3                         ;compares a with F3 key
    jp z,SolutionB                  ;if F3 jump to SolutionB
    cp K_F4                         ;compares a with F4 key
    jp z,SolutionC                  ;if F4 jump to SolutionC
    cp K_EXIT                       ;compares a with Exit key
    jp z,Start                      ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a with Alpha key
    call z,CalcOff                  ;if Alpha jump to CalcOff
    jr ABCLoop                      ;relative jump to QuitLoop

NotATriangle:
    call _clrScrn                   ;clears lcd and graph screen
    call MenuTitle                  ;goes to MenuTitle
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    call DrawMenuBox                ;goes to DrawMenuBox
    ld hl,$1212                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String27                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1820                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String28                  ;loads hl with string
    call _vputs                     ;prints in small text
    call _getkey                    ;pauses program until a key is pressed
    jp Pythagorean                  ;jump to Pythagorean

CheckNumber:
    call Input                      ;goes to Input
    xor a                           ;loads a with 0
    call _setXXop2                  ;move value of a(0) to op2
    call _cpop1op2                  ;compare op1(x1-x2) to op2(0)
    ret                             ;return to call

CantBe0orNegative:
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;sets hl with coordinates (0,0)
    ld hl,String26                  ;loads hl with string
    call _puts                      ;prints in large text
    call _getkey                    ;pauses program until a key is pressed
    jp Pythagorean                  ;jump to Pythagorean

PythagoreanAnswers:
    call _clrScrn                   ;clears lcd and graph screen
    call MenuTitle                  ;goes to MenuTitle
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    call DrawMenuBox                ;goes to DrawMenuBox
    call _rclX                      ;recalls real variable x(A) to op1
    ld hl,$0F1D                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,E1                        ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    call _rclY                      ;recalls real variable x(B) to op1
    ld hl,$1F1D                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,E2                        ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    call _op6toop1                  ;op6(C) is copied to op1
    ld hl,$2F1D                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,E3                        ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;pauses program until a key is pressed
    jp Start                        ;jumps to Start

SolutionA:
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;sets hl with coordinates (0,0)
    ld hl,E2                        ;loads hl with string
    call CheckNumber                ;goes to CheckNumber
    jr z,CantBe0orNegative          ;if op1 is 0 jump to CantBe0orNegative
    call _ckop1pos                  ;check if op1 is positive
    jr nz,CantBe0orNegative         ;if not jump to CantBe0orNegative
    call _stoY                      ;op1(B) is stored to real variable y
    call _FPSQUARE                  ;op1(B) ^2 ==> op1
    call _op1toop4                  ;op1(B^2) is copied to op4
    ld hl,E3                        ;loads hl with string
    call CheckNumber                ;goes to CheckNumber
    jp z,CantBe0orNegative          ;if op1 is 0 jump to CantBe0orNegative
    call _ckop1pos                  ;check if op1 is positive
    jp nz,CantBe0orNegative         ;if not jump to CantBe0orNegative
    call _op1toop6                  ;op1(C) is copied to op6
    call _FPSQUARE                  ;op1(C) ^2 ==> op1
    call _op4toop2                  ;op4(B^2) is copied to op2
    call _FPSUB                     ;op1(C^2) - op2(B^2) ==> op1
    call _ckop1pos                  ;check is op1 is positive
    jp nz,NotATriangle              ;if not jump to NotATriangle
    call _SQROOT                    ;root of op1(C^2 - B^2) ==> op1
    call _stoX                      ;op1(root C^2 - B^2) is stored to real variable x
    jp PythagoreanAnswers           ;jump to PythagoreanAnswers

SolutionB:
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;sets hl with coordinates (0,0)
    ld hl,E1                        ;loads hl with string
    call CheckNumber                ;goes to CheckNumber
    jp z,CantBe0orNegative          ;if op1 is 0 jump to CantBe0orNegative
    call _ckop1pos                  ;check if op1 is positive
    jp nz,CantBe0orNegative         ;if not jump to CantBe0orNegative
    call _stoX                      ;op1(A) is stored to real variable x
    call _FPSQUARE                  ;op1(A) ^2 ==> op1
    call _op1toop4                  ;op1(A^2) is copied to op4
    ld hl,E3                        ;loads hl with string
    call CheckNumber                ;goes to CheckNumber
    jp z,CantBe0orNegative          ;if op1 is 0 jump to CantBe0orNegative
    call _ckop1pos                  ;check if op1 is positive
    jp nz,CantBe0orNegative         ;if not jump to CantBe0orNegative
    call _op1toop6                  ;op1(C) is copied to op6
    call _FPSQUARE                  ;op1(C) ^2 ==> op1
    call _op4toop2                  ;op4(B^2) is copied to op2
    call _FPSUB                     ;op1(C^2) - op2(B^2) ==> op1
    call _ckop1pos                  ;check is op1 is positive
    jp nz,NotATriangle              ;if not jump to NotATriangle
    call _SQROOT                    ;root of op1(C^2 - A^2) ==> op1
    call _stoY                      ;op1(root C^2 - A^2) is stored to real variable y
    jp PythagoreanAnswers           ;jump to PythagoreanAnswers

SolutionC:
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;sets hl with coordinates (0,0)
    ld hl,E1                        ;loads hl with string
    call CheckNumber                ;goes to CheckNumber
    jp z,CantBe0orNegative          ;if op1 is 0 jump to CantBe0orNegative
    call _ckop1pos                  ;check if op1 is positive
    jp nz,CantBe0orNegative         ;if not jump to CantBe0orNegative
    call _stoX                      ;op1(A) is stored to real variable x
    call _FPSQUARE                  ;op1(A) ^2 ==> op1
    call _op1toop6                  ;op1(A^2) is copied to op6
    ld hl,E2                        ;loads hl with string
    call CheckNumber                ;goes to CheckNumber
    jp z,CantBe0orNegative          ;if op1 is 0 jump to CantBe0orNegative
    call _ckop1pos                  ;check if op1 is positive
    jp nz,CantBe0orNegative         ;if not jump to CantBe0orNegative
    call _stoY                      ;op1(B) is stored to real variable y
    call _FPSQUARE                  ;op1(B) ^2 ==> op1
    call _op6toop2                  ;op6(A^2) is copied to op2
    rst 30h                         ;op1(B^2) + op2(A^2) ==> op1
    call _SQROOT                    ;root of op1(A^2 + B^2) ==> op1
    call _op1toop6                  ;op1(root A^2 + B^2) is copied to op6
    jp PythagoreanAnswers           ;jump to PythagoreanAnswers


;=======================================
;=    Slope, Distance, and Midpoint    =
;=          By: Morgan Davies          =
;=                                     =
;=Solves For:           Inputs-        =
;=  Distance                x1=?       =
;=  Midpoint                y1=?       =
;=  Y=Mx+B Formula          x2=?       =
;=  X-Intercept             y2=?       =
;=  Y-Intercept                        =
;=  Slope                              =
;=======================================

X1Y1X2Y2:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup
    ld hl,E4
    call Input
    ld de,Var_X1
    call Create
    ld hl,E5
    call Input
    ld de,Var_Y1
    call Create
    ld hl,E6
    call Input
    ld de,Var_X2
    call Create
    ld hl,E7
    call Input
    ld de,Var_Y2
    call Create
    call _clrScrn                   ;clears lcd and graph screen
    call MenuTitle                  ;goes to MenuTitle
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    call DrawMenuBox                ;goes to DrawMenuBox
    ld hl,Var_X2
    call Recall
    rst 08h
    ld hl,Var_X1
    call Recall
    call _FPSUB
    call _op1toop4
    xor a                           ;loads a with 0
    call _setXXop2                  ;move value of a(0) to op2
    call _cpop1op2                  ;compare op1(x1-x2) to op2(0)
    jp z,Vertical                   ;if equal jump to Vertical
    ld hl,Var_Y2
    call Recall
    rst 08h
    ld hl,Var_Y1
    call Recall
    call _FPSUB
    xor a                           ;loads a with 0
    call _setXXop2                  ;move value of a(0) to op2
    call _cpop1op2                  ;compare op1(x1-x2) to op2(0)
    jp z,Horizontal                 ;if equal jump to Horizontal
    call _op4toop2
    call _FPDIV
    ld de,Var_M
    call Create
    ld hl,$0923                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String30                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,Var_M
    call Recall
    call DispAnswer
    ld hl,$2F0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String34                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3619                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String16                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    ld hl,String31                  ;loads hl with string
    call _vputs                     ;prints in small text
    rst 08h
    ld hl,Var_X1
    call Recall
    rst 28h
    rst 08h
    ld hl,Var_Y1
    call Recall
    call _FPSUB
    call DispAnswer
    ld hl,$170E                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String17                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    rst 08h
    xor a
    call _setXXop1
    call _FPSUB
    rst 08h
    ld hl,Var_M
    call Recall
    call _ex_op1_op2
    call _FPDIV
    ld hl,$100E                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String32                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
Distance:
    ld hl,Var_X1
    call Recall
    rst 08h
    ld hl,Var_X2
    call Recall
    call _FPSUB
    call _FPSQUARE
    call _op1toop4
    ld hl,Var_Y1
    call Recall
    rst 08h
    ld hl,Var_Y2
    call Recall
    call _FPSUB
    call _FPSQUARE
    call _op4toop2
    rst 30h
    call _SQROOT
    ld hl,$1E1A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String37                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    ld hl,Var_X2
    call Recall
    rst 08h
    ld hl,Var_X1
    call Recall
    rst 30h
    ld a,2
    call _setXXop2
    call _FPDIV
    ld hl,$2519                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String38                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    ld hl,String39
    call _vputs
    ld hl,Var_Y2
    call Recall
    rst 08h
    ld hl,Var_Y1
    call Recall
    rst 30h
    ld a,2
    call _setXXop2
    call _FPDIV
    call DispAnswer
    ld hl,String40
    call _vputs                     ;prints in small text
    call _getkey                    ;pauses program until a key is pressed
    jp Start                        ;jumps to Start

Vertical:
    ld hl,$0923                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String30                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,String35                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,Var_X1
    call Recall
    ld hl,$2F0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String34                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3619                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String15                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    ld hl,$100E                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String32                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    ld hl,$170E                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String17                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,String35                  ;loads hl with string
    call _vputs                     ;prints in small text
    jp Distance

Horizontal:
    ld hl,$0923                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String30                  ;loads hl with string
    call _vputs                     ;prints in small text
    xor a
    call _setXXop1
    call DispAnswer
    ld hl,Var_Y1
    call Recall
    ld hl,$2F0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String34                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3619                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String16                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer                 ;goes to DispAnswer
    ld hl,$170E                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String17                  ;loads hl with string
    call _vputs                     ;prints in small text
    call DispAnswer
    ld hl,$100E                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads _penCol with hl
    ld hl,String32                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,String35                  ;loads hl with string
    call _vputs                     ;prints in small text
    jp Distance

Set_Variables:
    xor a
    call _setXXop1
    ld de,Var_X1
    call Create
    ld de,Var_X2
    call Create
    ld de,Var_Y1
    call Create
    ld de,Var_Y2
    call Create
    ld de,Var_M
    call Create
    ret

Create:                     ;save num from OP1
    ld hl,_OP1              ;move 10 bytes from op1
    call _mov10b
    ret

Recall:                     ;restore num to OP1
    ld de,_OP1              ;number to op1
    call _mov10b
    ret

DrawLineHorizontalOn:
    ld (hl),%11111111               ;loads video mem @ hl w/ line
    inc hl                          ;moves one to the right
    djnz DrawLineHorizontalOn       ;repeat until line is drawn
    ret                             ;return to call

DrawLineHorizontalOff:
    ld (hl),%00000000               ;loads video mem @ hl w/ line
    inc hl                          ;moves one to the right
    djnz DrawLineHorizontalOff      ;repeat until line is drawn
    ret                             ;return to call

DrawVerticalLine:
    ld de,$10                       ;loads de with $10
LineLoop:
    ld a,(hl)                       ;loads a with contents of video mem @ hl
    or c                            ;turns on the pixels specified by c w/o affecting others
    ld (hl),a                       ;loads a back into video mem
    add hl,de                       ;moves to next line
    djnz LineLoop                   ;repeat until b=0
    ret                             ;return to call

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

DispAnswer:
    ld d,5                          ;load d with 6
    call _ROUND                     ;round op1 to D(6) digits
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _vputs                     ;prints answer in small text
    call _runindicoff               ;turn off run indicator
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    call Set_Variables              ;goes to Set_Variables
    res 3,(iy+5)                    ;reverts text back to black on white
    res trigdeg,(iy+trigflags)      ;change back to radian mode
    call _clrScrn                   ;clears the screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that quits program


String1:    .db "Quadratic Equation",0
String2:    .db "Pythagorean Theorem",0
String3:    .db "(x1,y1)(x2,y2)",0
String4:    .db "Quit",0
String5:    .db "By Morgan Davies",0
String6:    .db "      The  Quadster      ",0
String7:    .db "   Sir   Pythagoras   ",0
String8:    .db "  (x1,y1)   (x2,y2)  ",0
String9:    .db "If ",34,"A",34," is 0, then the"
            .db "graph is no longer a "
            .db "parabola, re-enter A.",0
String10:   .db "Discriminate = ",0
String11:   .db "X-Intercepts =",0
String12:   .db "x1 = ",0
String13:   .db "x2 = ",0
String14:   .db "Vertex =",0
String15:   .db "x = ",0
String16:   .db "y = ",0
String17:   .db "Y-Intercept = ",0
String18:   .db "Line of Symmetry = ",0
String19:   .db "  ",30," Graph Opens Up! ",30,"",0
String20:   .db "",31," Graph Opens Down! ",31,"",0

String23:   .db "A    B    C",0
String24:   .db "Solve For Which      "
            .db "   Variable?",0
String25:   .db "Use (F) Keys to Choose",0
String26:   .db "The ",34,"leg",34," of a       "
            .db "triangle cannot be 0 "
            .db "or negative.",0
String27:   .db "These  Numbers  Don't  Result",0 
String28:   .db "In  A  Right  Triangle!",0
String30:   .db "Slope = ",0
String31:   .db "(x)+",0
String32:   .db "X-Intercept = ",0

String34:   .db "Formula =",0
String35:   .db "<No Solution>",0
String36:   .db "Which Equation?",0
String37:   .db "Distance = ",0
String38:   .db "Midpoint = (",0
String39:   .db " , ",0
String40:   .db ")",0

E1:     .db "A=?",0
E2:     .db "B=?",0
E3:     .db "C=?",0
E4:     .db "x1=?",0
E5:     .db "y1=?",0
E6:     .db "x2=?",0
E7:     .db "y2=?",0

;========================================
;=       UlAligned Sprite Routine       =
;=              UberSprite              =
;=           By: Aaron Curtis           =
;=                                      =
;= Inputs                               =
;=      c  =  x-coordinate              =
;=      b  =  y-coordinate              =
;=      ix -> graphic                   =
;=                                      =
;= Destroys                             =
;=      ix,hl,de,bc,af,d                =
;=                                      =
;========================================

init_ubersprite:
    ld hl,spritedata
    ld d,l
gengfx:
    ld c,0
    ld b,c
gfxloop:
    push bc
    ld b,d
    ld a,d
    or a
    jr z,notshifted
    xor a
shiftloop:
    srl c
    rra
    djnz shiftloop
notshifted:
    ld (hl),c
    inc h
    ld (hl),a
    dec h
    inc hl
    pop bc
    inc c
    djnz gfxloop
    inc h
    inc d
    ld a,d
    cp 8
    jr nz,gengfx
    ret

ubersprite:
;==================
;FindPixil Routine=
;==================
    ld h,$fc/4              ;this will get multiplied by 4 later
                            ;(change the $fc to whatever if you're using a
                            ;  different video plane)
    ld a,b                  ;put y coord in a
    add a,a                 ;--multiply by 4
    add a,a                 ;/
    ld l,a                  ;now put that in l
    ld a,c                  ;put x coord in a
    rra                     ;\
    add hl,hl               ; \
    rra                     ;--- divide a by 8, multiply hl by 4 (must be in this order)
    add hl,hl               ; /
    rra                     ;/
                            ;so now hl is the y coord * 16, added to the appropriate offset
    add a,l
    ld l,a                  ;put the x coord together with hl, to get the offset in video mem
    ld a,c                  ;put the x coord in a
    and %00000111           ;this is the amount the pic must be shifted to the right
                            ;outputs: hl=postion in video mem  a=x-offset
    add a,a
    add a,spritedata/256    ;translate x-offset to address in spritedata
    ld d,a
    ld a,8                  ;doing this for 8 lines
    ld bc,15
uberloop:
    push af
    ld e,(ix+0)
    ld a,(de)                ;draw left half
    ;or (hl)                 ;** change this to xor (hl), and (hl), or whatever
    ld (hl),a
    inc hl
    inc d
    ld a,(de)                ;draw right half
    ;or (hl)                 ;** see above
    ld (hl),a
    dec d
    inc ix                  ;move to next line in graphic
    add hl,bc               ;and the next line on the screen
    pop af
    dec a
    jr nz,uberloop
    ret

LeftOpen:
    .db %00000110
    .db %00001000
    .db %00010000
    .db %00010000
    .db %00010000
    .db %00001000
    .db %00000110
    .db %00000000

RightOpen:
    .db %11000000
    .db %00100000
    .db %00010000
    .db %00010000
    .db %00010000
    .db %00100000
    .db %11000000
    .db %00000000

LeftClosed:
    .db %00000111
    .db %00001111
    .db %00011111
    .db %00011111
    .db %00011111
    .db %00001111
    .db %00000111
    .db %00000000

RightClosed:
    .db %11000000
    .db %11100000
    .db %11110000
    .db %11110000
    .db %11110000
    .db %11100000
    .db %11000000
    .db %00000000

TopLeft:
    .db %00001111
    .db %00110000
    .db %01000000
    .db %01000000
    .db %10000000
    .db %10000000
    .db %10000000
    .db %10000000

TopRight:
    .db %11110000
    .db %00001100
    .db %00000010
    .db %00000010
    .db %00000001
    .db %00000001
    .db %00000001
    .db %00000001

BottomLeft:
    .db %10000000
    .db %10000000
    .db %10000000
    .db %10000000
    .db %01000000
    .db %01000000
    .db %00110000
    .db %00001111

BottomRight:
    .db %00000001
    .db %00000001
    .db %00000001
    .db %00000001
    .db %00000010
    .db %00000010
    .db %00001100
    .db %11110000

.end
END